"use strict";
var SlideAnimator = (function () {
    function SlideAnimator() {
    }
    SlideAnimator.prototype.animateScroll = function (start, end, callback) {
        var _this = this;
        var difference = end - start;
        var step = function () {
            window.scrollTo(window.scrollX, window.scrollY + _this.scrollAmount(window.scrollY, difference, end));
            if (_this.checkIfDone(window.scrollY, difference, end)) {
                window.scrollTo(window.scrollX, end);
                callback();
            }
            else {
                window.requestAnimationFrame(step);
            }
        };
        window.requestAnimationFrame(step);
    };
    SlideAnimator.prototype.ease = function (end, current, power) {
        return (1 - current / end) * (Math.pow(power, 3)) + power;
    };
    SlideAnimator.prototype.scrollAmount = function (scrollPos, difference, end) {
        var easing = this.ease(Math.abs(difference), Math.abs(scrollPos - end), 6.66);
        return (difference > 0) ? easing : -easing;
    };
    SlideAnimator.prototype.checkIfDone = function (scrollPosition, difference, end) {
        if (difference > 0 && scrollPosition >= end) {
            return true;
        }
        else if (difference < 0 && scrollPosition <= end) {
            return true;
        }
        else {
            return false;
        }
    };
    return SlideAnimator;
}());
exports.SlideAnimator = SlideAnimator;
